	list p=16f84a
	#include <p16f84a.inc>
	radix dec
; Compiled with: PIC Simulator IDE v6.85
; Microcontroller model: PIC16F84A
; Clock frequency: 4.0 MHz
;
;       The address of 'i' (word) (global) is 0x20
	i EQU 0x20
;       The address of 'char' (byte) (global) is 0x22
	char EQU 0x22
;       The address of 'addr' (word) (global) is 0x23
	addr EQU 0x23
;       The address of 'data' (array 8) (byte) (global) is 0x25
	data EQU 0x25
;       The address of 'sda' (bit) (global) is 0x6,4
;       The address of 'scl' (bit) (global) is 0x6,5
; Begin
	R0L EQU 0xC
	R0H EQU 0xD
	R1L EQU 0xE
	R1H EQU 0xF
	R2L EQU 0x10
	R2H EQU 0x11
	R3L EQU 0x12
	R3H EQU 0x13
	R4L EQU 0x14
	R4H EQU 0x15
	R5L EQU 0x16
	R5H EQU 0x17
	SO_PORT EQU 0x18
	SO_BIT EQU 0x19
	SO_INTL EQU 0x1A
	SO_INTH EQU 0x1B
	SCL_PORT EQU 0x1C
	SCL_BIT EQU 0x1D
	SDA_PORT EQU 0x1E
	SDA_BIT EQU 0x1F
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0002
	ORG 0x0004
	RETFIE
; Begin of program
L0002:
; 1: Dim i As Word
; 2: Dim char As Byte
; 3: Dim addr As Word
; 4: Dim data(8) As Byte
; 5: 
; 6: Config PORTA = Output
	BSF STATUS,RP0
	CLRF TRISA
; 7: Config PORTB = Output
	CLRF TRISB
	BCF STATUS,RP0
; 8: 
; 9: Symbol sda = PORTB.4 'this is the only change i have made
; 10: Symbol scl = PORTB.5
; 11: Define SEROUT_DELAYUS = 5000
; 12: 
; 13: addr = 0
	CLRF 0x23
	CLRF 0x24
; 14: 
; 15: loop:
L0001:
; 16: char = 0
	CLRF 0x22
; 17: For addr = 0 To 7
	CLRF 0x23
	CLRF 0x24
L0003:
	MOVF 0x23,W
	MOVWF R0L
	MOVF 0x24,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x07
	CALL C006
	BTFSS STATUS,Z
	GOTO L0004
; 18: data = LookUp("01234567"), char
	MOVF 0x22,W
	SUBLW 0x07
	BTFSS STATUS,C
	GOTO L0005
	CALL L0006
	MOVWF 0x25
	GOTO L0005
L0006:
	MOVLW 0x00
	MOVWF PCLATH
	MOVF 0x22,W
	ADDWF PCL,F
	RETLW 0x30
	RETLW 0x31
	RETLW 0x32
	RETLW 0x33
	RETLW 0x34
	RETLW 0x35
	RETLW 0x36
	RETLW 0x37
L0005:
; 19: I2CWrite sda, scl, 0xa0, addr, data
	MOVLW 0x06
	MOVWF SDA_PORT
	MOVLW 0x10
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISB,4
	BCF STATUS,RP0
	MOVLW 0x06
	MOVWF SCL_PORT
	MOVLW 0x20
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISB,5
	BCF STATUS,RP0
	CALL IC41
	CALL IC41
	CALL IC31
	MOVLW 0xA0
	CALL IC01
	MOVF 0x24,W
	CALL IC01
	MOVF 0x23,W
	CALL IC01
	MOVF 0x25,W
	CALL IC01
	CALL IC41
; 20: WaitMs 5
	MOVLW 0x05
	MOVWF R0L
	CLRF R0H
	CALL W001
; 21: char = char + 1
	MOVF 0x22,W
	ADDLW 0x01
	MOVWF 0x22
; 22: Next addr
	MOVLW 0x01
	ADDWF 0x23,F
	MOVLW 0x00
	BTFSC STATUS,C
	ADDLW 0x01
	BTFSC STATUS,C
	GOTO L0004
	ADDWF 0x24,F
	BTFSS STATUS,C
	GOTO L0003
L0004:
; 23: WaitMs 5
	MOVLW 0x05
	MOVWF R0L
	CLRF R0H
	CALL W001
; 24: 
; 25: char = 0
	CLRF 0x22
; 26: For addr = 8 To 15
	MOVLW 0x08
	MOVWF 0x23
	CLRF 0x24
L0007:
	MOVF 0x23,W
	MOVWF R0L
	MOVF 0x24,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x0F
	CALL C006
	BTFSS STATUS,Z
	GOTO L0008
; 27: data = LookUp("ABCDEFGH"), char
	MOVF 0x22,W
	SUBLW 0x07
	BTFSS STATUS,C
	GOTO L0009
	CALL L0010
	MOVWF 0x25
	GOTO L0009
L0010:
	MOVLW 0x00
	MOVWF PCLATH
	MOVF 0x22,W
	ADDWF PCL,F
	RETLW 0x41
	RETLW 0x42
	RETLW 0x43
	RETLW 0x44
	RETLW 0x45
	RETLW 0x46
	RETLW 0x47
	RETLW 0x48
L0009:
; 28: I2CWrite sda, scl, 0xa0, addr, data
	MOVLW 0x06
	MOVWF SDA_PORT
	MOVLW 0x10
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISB,4
	BCF STATUS,RP0
	MOVLW 0x06
	MOVWF SCL_PORT
	MOVLW 0x20
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISB,5
	BCF STATUS,RP0
	CALL IC41
	CALL IC41
	CALL IC31
	MOVLW 0xA0
	CALL IC01
	MOVF 0x24,W
	CALL IC01
	MOVF 0x23,W
	CALL IC01
	MOVF 0x25,W
	CALL IC01
	CALL IC41
; 29: WaitMs 5
	MOVLW 0x05
	MOVWF R0L
	CLRF R0H
	CALL W001
; 30: char = char + 1
	MOVF 0x22,W
	ADDLW 0x01
	MOVWF 0x22
; 31: Next addr
	MOVLW 0x01
	ADDWF 0x23,F
	MOVLW 0x00
	BTFSC STATUS,C
	ADDLW 0x01
	BTFSC STATUS,C
	GOTO L0008
	ADDWF 0x24,F
	BTFSS STATUS,C
	GOTO L0007
L0008:
; 32: WaitMs 5
	MOVLW 0x05
	MOVWF R0L
	CLRF R0H
	CALL W001
; 33: 
; 34: 
; 35: For addr = 8 To 15
	MOVLW 0x08
	MOVWF 0x23
	CLRF 0x24
L0011:
	MOVF 0x23,W
	MOVWF R0L
	MOVF 0x24,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x0F
	CALL C006
	BTFSS STATUS,Z
	GOTO L0012
; 36: I2CRead sda, scl, 0xa0, addr, data(addr)
	MOVLW 0x06
	MOVWF SDA_PORT
	MOVLW 0x10
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISB,4
	BCF STATUS,RP0
	MOVLW 0x06
	MOVWF SCL_PORT
	MOVLW 0x20
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISB,5
	BCF STATUS,RP0
	CALL IC41
	CALL IC41
	CALL IC31
	MOVLW 0xA0
	CALL IC01
	MOVF 0x24,W
	CALL IC01
	MOVF 0x23,W
	CALL IC01
	CALL IC41
	CALL IC31
	MOVLW 0xA1
	CALL IC01
	CALL IC11
	MOVWF R5L
	MOVF 0x23,W
	ADDLW 0x25
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
	CALL IC41
; 37: WaitMs 5
	MOVLW 0x05
	MOVWF R0L
	CLRF R0H
	CALL W001
; 38: Next addr
	MOVLW 0x01
	ADDWF 0x23,F
	MOVLW 0x00
	BTFSC STATUS,C
	ADDLW 0x01
	BTFSC STATUS,C
	GOTO L0012
	ADDWF 0x24,F
	BTFSS STATUS,C
	GOTO L0011
L0012:
; 39: WaitMs 5
	MOVLW 0x05
	MOVWF R0L
	CLRF R0H
	CALL W001
; 40: 
; 41: For addr = 8 To 15
	MOVLW 0x08
	MOVWF 0x23
	CLRF 0x24
L0013:
	MOVF 0x23,W
	MOVWF R0L
	MOVF 0x24,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x0F
	CALL C006
	BTFSS STATUS,Z
	GOTO L0014
; 42: Serout PORTA.3, 2400, data(addr)
	BSF STATUS,RP0
	BCF TRISA,3
	BCF STATUS,RP0
	BSF PORTA,3
	MOVLW 0x05
	MOVWF SO_PORT
	MOVLW 0x08
	MOVWF SO_BIT
	MOVLW 0x93
	MOVWF SO_INTL
	MOVLW 0x01
	MOVWF SO_INTH
	MOVF 0x23,W
	ADDLW 0x25
	MOVWF FSR
	MOVF INDF,W
	CALL SO01
; 43: WaitMs 10
	MOVLW 0x0A
	MOVWF R0L
	CLRF R0H
	CALL W001
; 44: Next addr
	MOVLW 0x01
	ADDWF 0x23,F
	MOVLW 0x00
	BTFSC STATUS,C
	ADDLW 0x01
	BTFSC STATUS,C
	GOTO L0014
	ADDWF 0x24,F
	BTFSS STATUS,C
	GOTO L0013
L0014:
; 45: Serout PORTA.3, 2400, CrLf
	BSF STATUS,RP0
	BCF TRISA,3
	BCF STATUS,RP0
	BSF PORTA,3
	MOVLW 0x05
	MOVWF SO_PORT
	MOVLW 0x08
	MOVWF SO_BIT
	MOVLW 0x93
	MOVWF SO_INTL
	MOVLW 0x01
	MOVWF SO_INTH
	MOVLW 0x0D
	CALL SO01
	MOVLW 0x0A
	CALL SO01
; 46: 
; 47: For addr = 0 To 7
	CLRF 0x23
	CLRF 0x24
L0015:
	MOVF 0x23,W
	MOVWF R0L
	MOVF 0x24,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x07
	CALL C006
	BTFSS STATUS,Z
	GOTO L0016
; 48: I2CRead sda, scl, 0xa0, addr, data(addr)
	MOVLW 0x06
	MOVWF SDA_PORT
	MOVLW 0x10
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISB,4
	BCF STATUS,RP0
	MOVLW 0x06
	MOVWF SCL_PORT
	MOVLW 0x20
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISB,5
	BCF STATUS,RP0
	CALL IC41
	CALL IC41
	CALL IC31
	MOVLW 0xA0
	CALL IC01
	MOVF 0x24,W
	CALL IC01
	MOVF 0x23,W
	CALL IC01
	CALL IC41
	CALL IC31
	MOVLW 0xA1
	CALL IC01
	CALL IC11
	MOVWF R5L
	MOVF 0x23,W
	ADDLW 0x25
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
	CALL IC41
; 49: WaitMs 5
	MOVLW 0x05
	MOVWF R0L
	CLRF R0H
	CALL W001
; 50: Next addr
	MOVLW 0x01
	ADDWF 0x23,F
	MOVLW 0x00
	BTFSC STATUS,C
	ADDLW 0x01
	BTFSC STATUS,C
	GOTO L0016
	ADDWF 0x24,F
	BTFSS STATUS,C
	GOTO L0015
L0016:
; 51: WaitMs 5
	MOVLW 0x05
	MOVWF R0L
	CLRF R0H
	CALL W001
; 52: 
; 53: For addr = 0 To 7
	CLRF 0x23
	CLRF 0x24
L0017:
	MOVF 0x23,W
	MOVWF R0L
	MOVF 0x24,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x07
	CALL C006
	BTFSS STATUS,Z
	GOTO L0018
; 54: Serout PORTA.3, 2400, data(addr)
	BSF STATUS,RP0
	BCF TRISA,3
	BCF STATUS,RP0
	BSF PORTA,3
	MOVLW 0x05
	MOVWF SO_PORT
	MOVLW 0x08
	MOVWF SO_BIT
	MOVLW 0x93
	MOVWF SO_INTL
	MOVLW 0x01
	MOVWF SO_INTH
	MOVF 0x23,W
	ADDLW 0x25
	MOVWF FSR
	MOVF INDF,W
	CALL SO01
; 55: WaitMs 10
	MOVLW 0x0A
	MOVWF R0L
	CLRF R0H
	CALL W001
; 56: Next addr
	MOVLW 0x01
	ADDWF 0x23,F
	MOVLW 0x00
	BTFSC STATUS,C
	ADDLW 0x01
	BTFSC STATUS,C
	GOTO L0018
	ADDWF 0x24,F
	BTFSS STATUS,C
	GOTO L0017
L0018:
; 57: Serout PORTA.3, 2400, CrLf
	BSF STATUS,RP0
	BCF TRISA,3
	BCF STATUS,RP0
	BSF PORTA,3
	MOVLW 0x05
	MOVWF SO_PORT
	MOVLW 0x08
	MOVWF SO_BIT
	MOVLW 0x93
	MOVWF SO_INTL
	MOVLW 0x01
	MOVWF SO_INTH
	MOVLW 0x0D
	CALL SO01
	MOVLW 0x0A
	CALL SO01
; 58: 
; 59: 'plays a tone on the piezo
; 60: FreqOut PORTB.1, 299, 8
	MOVLW 0x06
	MOVWF FSR
	MOVLW 0x02
	MOVWF R5L
	MOVLW 0x87
	MOVWF R0L
	MOVLW 0x06
	MOVWF R0H
	MOVLW 0x02
	MOVWF R1L
	MOVLW 0x00
	MOVWF R1H
	CALL FQ01
; 61: 
; 62: For i = 400 To 5000 Step 130
	MOVLW 0x90
	MOVWF 0x20
	MOVLW 0x01
	MOVWF 0x21
L0019:
	MOVF 0x20,W
	MOVWF R0L
	MOVF 0x21,W
	MOVWF R0H
	MOVLW 0x13
	MOVWF R1H
	MOVLW 0x88
	CALL C006
	BTFSS STATUS,Z
	GOTO L0020
; 63: FreqOut PORTB.1, 900, 10
	MOVLW 0x06
	MOVWF FSR
	MOVLW 0x02
	MOVWF R5L
	MOVLW 0x2B
	MOVWF R0L
	MOVLW 0x02
	MOVWF R0H
	MOVLW 0x09
	MOVWF R1L
	MOVLW 0x00
	MOVWF R1H
	CALL FQ01
; 64: Next i
	MOVLW 0x82
	ADDWF 0x20,F
	MOVLW 0x00
	BTFSC STATUS,C
	ADDLW 0x01
	BTFSC STATUS,C
	GOTO L0020
	ADDWF 0x21,F
	BTFSS STATUS,C
	GOTO L0019
L0020:
; 65: 
; 66: Goto loop
	GOTO L0001
; 67: End
L0021:	GOTO L0021
; End of program
L0022:	GOTO L0022
; Comparison Routine
C001:	MOVWF R1L
	MOVLW 0x05
	GOTO C007
C002:	MOVWF R1L
	MOVLW 0x02
	GOTO C007
C003:	MOVWF R1L
	MOVLW 0x06
	GOTO C007
C004:	MOVWF R1L
	MOVLW 0x03
	GOTO C007
C005:	MOVWF R1L
	MOVLW 0x04
	GOTO C007
C006:	MOVWF R1L
	MOVLW 0x01
	GOTO C007
C007:	MOVWF R4L
	MOVF R1H,W
	SUBWF R0H,W
	BTFSS STATUS,Z
	GOTO C008
	MOVF R1L,W
	SUBWF R0L,W
C008:	MOVLW 0x04
	BTFSC STATUS,C
	MOVLW 0x01
	BTFSC STATUS,Z
	MOVLW 0x02
	ANDWF R4L,W
	BTFSS STATUS,Z
	MOVLW 0xFF
	RETURN
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x12
	MOVWF R1L
W005:	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; Waitus Routine - Word Argument
Y001:	MOVLW 0x10
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
Y002:	MOVLW 0x0A
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
; Serout Routine
SO01:	MOVWF R5L
	MOVLW 0x88
	MOVWF R4L
	MOVLW 0x13
	MOVWF R4H
	CALL Y001
	MOVF SO_PORT,W
	MOVWF FSR
	MOVLW 0x09
	MOVWF R5H
	BCF STATUS,C
SO02:	CALL SO03
	RRF R5L,F
	DECFSZ R5H,F
	GOTO SO02
	BSF STATUS,C
	CALL SO03
	RETURN
SO03:	MOVF INDF,W
	IORWF SO_BIT,W
	BTFSS STATUS,C
	XORWF SO_BIT,W
	MOVWF INDF
	MOVF SO_INTL,W
	MOVWF R4L
	MOVF SO_INTH,W
	MOVWF R4H
	CALL Y001
	RETURN
; I2CWrite Routine
IC01:	MOVWF R0L
	MOVLW 0x08
	MOVWF R0H
IC02:	RLF R0L,F
	BTFSC STATUS,C
	CALL IC20
	BTFSS STATUS,C
	CALL IC21
	CALL IC22
	CALL IC23
	DECFSZ R0H,F
	GOTO IC02
	CALL IC24
	CALL IC03
	CALL IC25
	CALL IC21
	RETURN
IC03:	CALL IC22
	MOVF SDA_PORT,W
	MOVWF FSR
	MOVF SDA_BIT,W
	ANDWF INDF,W
	ADDLW 0xFF
	CALL IC23
	RETURN
IC31:	CALL IC21
	CALL IC23
	GOTO IC29
IC41:	CALL IC22
	CALL IC20
	GOTO IC29
IC20:	MOVF SDA_PORT,W
	MOVWF FSR
	MOVF SDA_BIT,W
	IORWF INDF,F
	GOTO IC28
IC21:	MOVF SDA_PORT,W
	MOVWF FSR
	COMF SDA_BIT,W
	ANDWF INDF,F
	GOTO IC28
IC22:	MOVF SCL_PORT,W
	MOVWF FSR
	MOVF SCL_BIT,W
	IORWF INDF,F
	GOTO IC28
IC23:	MOVF SCL_PORT,W
	MOVWF FSR
	COMF SCL_BIT,W
	ANDWF INDF,F
	GOTO IC28
IC28:	BSF FSR,7
	COMF INDF,W
	BCF FSR,7
	ANDWF INDF,F
IC29:	NOP
	NOP
	RETURN
IC24:	MOVF SDA_PORT,W
	MOVWF FSR
	BSF FSR,7
	MOVF SDA_BIT,W
	IORWF INDF,F
	RETURN
IC25:	MOVF SDA_PORT,W
	MOVWF FSR
	BSF FSR,7
	COMF SDA_BIT,W
	ANDWF INDF,F
	RETURN
; I2CRead Routine
IC11:	CALL IC24
	MOVLW 0x08
	MOVWF R0H
IC12:	CALL IC03
	RLF R0L,F
	DECFSZ R0H,F
	GOTO IC12
	CALL IC25
	CALL IC20
	CALL IC22
	CALL IC23
	CALL IC21
	MOVF R0L,W
	RETURN
IC13:	CALL IC24
	MOVLW 0x08
	MOVWF R0H
IC14:	CALL IC03
	RLF R0L,F
	DECFSZ R0H,F
	GOTO IC14
	CALL IC25
	CALL IC21
	CALL IC22
	CALL IC23
	MOVF R0L,W
	RETURN
; FreqOut Routine (High)
FQ01:	MOVF R5L,W
	IORWF INDF,F
	MOVF R0L,W
	MOVWF R4L
	MOVF R0H,W
	MOVWF R4H
	CALL Y001
	MOVLW 0x01
	SUBWF R1L,F
	BTFSS STATUS,C
	DECF R1H,F
	COMF R5L,W
	ANDWF INDF,F
	MOVF R0L,W
	MOVWF R4L
	MOVF R0H,W
	MOVWF R4H
	CALL Y001
	MOVF R1L,F
	BTFSS STATUS,Z
	GOTO FQ01
	MOVF R1H,F
	BTFSS STATUS,Z
	GOTO FQ01
	RETURN
; End of listing
	END
